if ~isempty(findobj('Name','Adaptive Systems - Demo Package'))
   figure(findobj('Name','Adaptive Systems - Demo Package'))
   return
end

clear all
close all
start;

% Matlab4 standard color
colordef none

screen=get(0,'ScreenSize');
fig=figure('MenuBar','none','numberTitle','off','UserData','Main window',...
	'Position',[screen(3)/2-275 screen(4)/2-175 550 250],'Resize','off',...
	'Name','Adaptive Systems - Demo Package');


five=uimenu(fig,'Label','File');
   uimenu(five,'Label','Exit','Callback','close all,clear all,colordef white')

one=uimenu(fig,'Label','Adaptive systems','UserData','main');
uimenu(one,'Label','Adaptive Pole Assignment','Callback','apa');
uimenu(one,'Label','Direct Adaptive Model Reference Control',...
	   'Callback','damrc')
one_three=uimenu(one,'Label','Universal Controllers');
   uimenu(one_three,'Label','Case I: The sign of the high frequency gain is known.','CallBack','uc_1');
   uimenu(one_three,'Label','Case II: The sign of the high frequency gain is unknown.','CallBack','uc_2');

two = uimenu(fig,'Label','Info','UserData','main');
  uimenu(two,'Label','About the program','Callback','info_pro')
  uimenu(two,'Label','About the author','Callback','info_au')

six=uimenu(fig,'Label','Logo','UserData','main');
uimenu(six,'Label','Logo','Callback','start','UserData','main')


h(1)=line([-0.5 2],[8.75 8.75]);	      % r,input -> plant
h(2)=line([1.8 2 1.8],[8.9 8.75 8.6]);

h(3)=line([0.1 0.1 0.4 0.5 0.6 4.5],[8.75 3 3 3.3 3 3]);% r -> error model
h(4)=line([4.3 4.5 4.3],[3.2 3 2.8]);

h(5)=line([1 1 2],[8.75 4.75 4.75]);%input -> model
h(6)=line([1.8 2 1.8],[4.95 4.75 4.55]);

h(7)=line([1 4.5],[6.75 6.75]);% input -> error model
h(8)=line([4.3 4.5 4.3],[6.95 6.75 6.55]);

h(9)=line([3.5 10],[8.75 8.75]);%plant -> output
h(10)=line([9.8 10 9.8],[8.95 8.75 8.55]);

h(11)=line([3.5 4.5],[4.75 4.75]);% model -> error model
h(12)=line([4.3 4.5 4.3],[4.95 4.75 4.55]);

h(13)=line([5.25 5.25],[8.75 7]);% output -> error model
h(14)=line([5.15 5.25 5.35],[7.2 7 7.2]);

h(15)=line([6 6.65 6.75 6.85 7.5],[4.75 4.75 4.95 4.75 4.75]);% error model -> tuner
h(16)=line([7.3 7.5 7.3],[4.95 4.75 4.55]);

h(17)=line([6.75 6.75 3.5],[8.75 1.25 1.25]);% output  -> controller
h(18)=line([3.7 3.5 3.7],[1.45 1.25 1.05]);

h(19)=line([9 10 10 3.8],[4.75 4.75 0.7 0.7]);% tuner -> controller
h(20)=line([4 3.8 4],[0.9 0.7 0.5]);

h(21)=line([2.75 2.75 2.95 2.75 2.75],[4 3.2 3 2.8 2]);% model -> controller
h(22)=line([2.65 2.75 2.85],[2.2 2 2.2]);

h(23)=line([0.5 0.5 2],[8.75 1.25 1.25]);%controller -> input
h(24)=line([0.4 0.5 0.6],[8.55 8.75 8.55]);

h(25)=line([1.7 3.8 3.8 1.7 1.7],[0.2 0.2 5.8 5.8 0.2]); % frame

h(26)=line([2 3.5 3.5 2 2],[0.5 0.5 2 2 0.5]); % Controller
h(27)=line([2 3.5 3.5 2 2],[4 4 5.5 5.5 4]); % Model
h(28)=line([4.5 6 6 4.5 4.5],[2.5 2.5 7 7 2.5]); % Error model
h(29)=line([2 3.5 3.5 2 2],[8 8 9.5 9.5 8]); % Plant
h(30)=line([7.5 9 9 7.5 7.5],[4 4 5.5 5.5 4]); % Tuner
axis([-0.5 10 0 10])
axis off
set([h(1:24), h(26:30)],'Color',[1 1 1])
set(h(25),'Color',[1 1 0])

han(1)=text(0,9.5,'r');
han(2)=text(0.5,9.5,'input u');
han(3)=text(2.3,8.75,'plant');
han(4)=text(2.2,4.75,'model');
han(5)=text(2.1,1.25,'controller');
han(6)=text(7,9.5,'output y');
han(7)=text(4.8,5,'error');
han(8)=text(4.8,4,'model');
han(9)=text(7.8,4.75,'tuner');
han(10)=text(6.4,4.3,'e');

set(han,'HorizontalAlignment','left','FontSize',10,'Color',[1 1 1]);

set(fig,'HandleVisibility','on')

clear
