if strcmp(string,'sys_mr')

  % Callback for button OK in the window with the name "Unknown system"

  value1=str2num(get(findobj('UserData','a_true'),'String'));
  value2=str2num(get(findobj('UserData','b_true'),'String'));
  pom = find(value2);
  value3=str2num(get(findobj('UserData','bm_bar'),'String'));
  if isempty(value1) | isempty(value2) | isempty(value3)
     errormes('data');
     clear value1 value2 value3 pom
     return
  elseif check_m(value1)==1 | check_m(value2)==1
     errormes('vectors')
     clear value1 value2 value3 pom
     return
  elseif length(value1)~=length(value2)
     errormes('NotEqual')
     clear value1 value2 value3 pom
     return
  elseif length(value3)>1 
     errormes('bm_bar_scalar')
     clear value1 value2 value3 pom
     return 
  elseif ~any(value2)
     errormes('b_zero')
     clear value1 value2 value3 pom
     return 
  elseif any(abs(roots(value2))>=1) 
     errormes('b_stable')
     clear value1 value2 value3 
     return 
  elseif value2(pom(1)) < 0 
     errormes('b_l_coeff')
     clear value1 value2 value3 pom
     return 
  end
  n=length(value1);
  value1=value1(:);
  value2=value2(:);
  if ~det(ctrb([[zeros(1,n-1) ; eye(n-1)] -flipud(value1)],flipud(value2)))
     errormes('NotContr'),clear value1 value2 value3 pom
  elseif value3<=value2(pom(1))
     errormes('bm_bar<n',value2(pom(1))), clear value1 value2 value3 pom
  else 
    set(findobj('Label','Unknown system'),'Checked','on')
    old_n=length(Sys)/2;
    Sys=[-value1;value2];bm_bar=value3;
    n=length(Sys)/2;ready(1)=1;n_r=n+1-length(find(value2));
    if n~=old_n
       ready=[[1 0 0 0], ready(5:6), [0 1],ready(9:10)];
       set(findobj('Label','Initial values'),'Checked','off')
       set(findobj('Label','Filter'),'Checked','off')
       set(findobj('Label','Recursive Least Square'),'Checked','off')
       set(findobj('Label','Initial estimates of the controller parameters'),'Checked','off')
       set(findobj('Label','An initial state of the system'),'Checked','on')
       set(findobj('Label','Polynomial H'),'Checked','off')
       set(findobj('Label','Initial state'),'Checked','off')
       if n>number_of_iter
         set(findobj('Label','Number of iterations'),'Checked','off')
         ready(9)=0;
       end
       if any(any(phases>7))
         set(findobj('Label','Phase portraits'),'Checked','off')
         phases = zeros(3,2);
       end
       set(findobj('Label','Start simulation'),'Enable','off')
       set(findobj('Label','with RLS algorithm'),'Enable','off')
       if n_r~=(length(E_polynomial)-1)
         ready(5)=0;E_polynomial = [];
         set(findobj('Label','Reference model'),'Checked','off')         
         set(findobj('Label','Reference model polynomial'),'Checked','off')         
       end
       init_est = [];init_st = zeros(2*n-1,1);init_X=[];H_polynomial=[];
       RLS_par=[];
    else
       if n_r~=(length(E_polynomial)-1)
         ready(5)=0;E_polynomial = [];
         set(findobj('Label','Reference model'),'Checked','off')         
         set(findobj('Label','Reference model polynomial'),'Checked','off')         
         set(findobj('Label','Start simulation'),'Enable','off')
       end
    end
    if ~isempty(findobj('Label','Unknown system','Checked','on'))
       set(findobj('Label','Initial values'),'Enable','on')
       set(findobj('Label','Filter'),'Enable','on')
       set(findobj('Label','Reference model'),'Enable','on')         
       set(findobj('Label','Recursive Least Square'),'Enable','on')
       set(findobj('Label','Number of iterations'),'Enable','on')
       set(findobj('Label','Phase portraits'),'Enable','on')
    end
    clear old_n
    check_mr
    close(findobj('Name','Unknown system'))
    if ~isempty(findobj('Name','Introduced parameters gallery'))
        show_mr
    end
    message('IsMinPhase')
    clear value1 value2 value3
  end

elseif strcmp(string,'rls_sim')
   [y,y_r,u,model_error,r,da_in_ratio,rs_ou_ratio]=sim_mr(Sys,bm_bar,E_polynomial,...
         which_signal,signal_par,init_est,init_st,init_X,H_polynomial,...
         threshold,number_of_iter,RLS_par,casc,window,combination,phases);
   set(findobj('Label','Variables values'),'Enable','on')
   if ~isempty(findobj('Name','Calculated variables gallery'))
      var_mr(y,y_r,u,model_error,r,da_in_ratio,rs_ou_ratio)
   end
elseif strcmp(string,'nlms_sim')
   [y,y_r,u,model_error,r,da_in_ratio,rs_ou_ratio]=sim_mr(Sys,bm_bar,E_polynomial,...
         which_signal,signal_par,init_est,init_st,init_X,H_polynomial,...
         threshold,number_of_iter,NLMS_par,casc,window,combination,phases);
   set(findobj('Label','Variables values'),'Enable','on')
   if ~isempty(findobj('Name','Calculated variables gallery'))
      var_mr(y,y_r,u,model_error,r,da_in_ratio,rs_ou_ratio)
   end
elseif strcmp(string,'lms_sim')
   [y,y_r,u,model_error,r,da_in_ratio,rs_ou_ratio]=sim_mr(Sys,bm_bar,E_polynomial,...
         which_signal,signal_par,init_est,init_st,init_X,H_polynomial,...
         threshold,number_of_iter,LMS_par,casc,window,combination,phases);
   set(findobj('Label','Variables values'),'Enable','on')
   if ~isempty(findobj('Name','Calculated variables gallery'))
      var_mr(y,y_r,u,model_error,r,da_in_ratio,rs_ou_ratio)
   end
end
