% Pawel Stadnik August 30 1997
% All Rights Reserved


if ~isempty(findobj('Name','Cascade'))
   figure(findobj('Name','Cascade'))
   return
end
if ~isempty(findobj('Name','Direct Adaptive Model Reference Control'))
  screen=get(0,'ScreenSize');
  fig=figure('MenuBar','none','numberTitle','off','UserData','Figure',...
             'Position',[screen(3)/2-300 screen(4)/2-175 600 350],...
             'Resize','off','Name','Cascade');
  axis off

  handle = text(-0.1,0.9,'The plots of selected magnitudes will be displayed in a cascade:');
  set(handle,'HorizontalAlignment','left','Color',[1 1 1])

  uicontrol('Style','checkbox','Position',[50 225 150 20],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'String','Output','Value',casc(1),...
            'Callback','casc(1)=get(gco,(''Value''));')
  uicontrol('Style','checkbox','Position',[50 175 150 20],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'String','Reference output','Value',casc(2),...
            'Callback','casc(2)=get(gco,(''Value''));')
  uicontrol('Style','checkbox','Position',[50 125 150 20],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'String','Input','Value',casc(3),...
            'Callback','casc(3)=get(gco,(''Value''));')
  uicontrol('Style','checkbox','Position',[50 75 150 20],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'String','Model error','Value',casc(4),...
            'Callback','casc(4)=get(gco,(''Value''));')
  uicontrol('Style','checkbox','Position',[50 25 150 20],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'String','Reference signal','Value',casc(5),...
            'Callback','casc(5)=get(gco,(''Value''));')

  uicontrol('Style','checkbox','Position',[250 225 210 20],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'String','Desired/actual input ratio','Value',casc(6),...
            'Callback','casc(6)=get(gco,(''Value''));')
  uicontrol('Style','checkbox','Position',[250 175 210 20],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'String','Reference/system output ratio','Value',casc(7),...
            'Callback','casc(7)=get(gco,(''Value''));')
  uicontrol('Style','checkbox','Position',[250 125 210 20],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'String','Estimates of "c_u" parameters','Value',casc(8),...
            'Callback','casc(8)=get(gco,(''Value''));')
  uicontrol('Style','checkbox','Position',[250 75 210 20],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'String','Estimates of "c_y" parameters','Value',casc(9),...
            'Callback','casc(9)=get(gco,(''Value''));')
  uicontrol('Style','checkbox','Position',[250 25 210 20],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'String','Estimate of "c_r" parameter','Value',casc(10),...
            'Callback','casc(10)=get(gco,(''Value''));')

uicontrol(fig,'Style','Pushbutton','Position',[500 175 75 20],...
          'String','OK','Callback',...
     ['close(gcf),if ~isempty(find(casc)),set(findobj(''Label'',''Cascade''),''Checked'',''on''),',...
      'ready(10)=1;check_mr;else set(findobj(''Label'',''Cascade''),''Checked'',''off''),',...
      'check_mr;end,'])

uicontrol(fig,'Style','Pushbutton','Position',[500 125 75 20],...
          'String','Cancel','UserData',casc,...
          'Callback','casc = get(gco,''UserData'');close(gcf)')
clear fig screen handle
end











