% Pawel Stadnik August 30 1997
% All Rights Reserved


if ~isempty(findobj('Name','Combination'))
   figure(findobj('Name','Combination'))
   return
end
if ~isempty(findobj('Name','The sign of the high frequency gain is known.'))|...
   ~isempty(findobj('Name','The sign of the high frequency gain is unknown.'))
  screen=get(0,'ScreenSize');
  fig=figure('MenuBar','none','numberTitle','off','UserData','Figure',...
             'Position',[screen(3)/2-250 screen(4)/2-150 500 300],...
             'Resize','off','Name','Combination');
  axis off

  handle = text(0.5,0.9,'The plots of selected magnitudes will be combined within one figure.');
  set(handle,'HorizontalAlignment','center')

%First group

  h(1)=text(0,0.65,'1st figure');
  uicontrol('style','frame','position',[40 40 120 140],'BackgroundColor',[0.2 0.4 0.8])
  uicontrol('Style','checkbox','Position',[50 150 100 20],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'String','Output','Value',combination(1,1),...
            'Callback','combination(1,1)=get(gco,(''Value''));')
  uicontrol('Style','checkbox','Position',[50 100 100 20],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'String','Input','Value',combination(1,2),...
            'Callback','combination(1,2)=get(gco,(''Value''));')
  uicontrol('Style','checkbox','Position',[50 50 100 20],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'String','k','Value',combination(1,3),...
            'Callback','combination(1,3)=get(gco,(''Value''));')

%Second group

  h(2)=text(0.4,0.65,'2nd figure');
  uicontrol('style','frame','position',[190 40 120 140],'BackgroundColor',[0.2 0.4 0.8])
  uicontrol('Style','checkbox','Position',[200 150 100 20],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'String','Output','Value',combination(2,1),...
            'Callback','combination(2,1)=get(gco,(''Value''));')
  uicontrol('Style','checkbox','Position',[200 100 100 20],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'String','Input','Value',combination(2,2),...
            'Callback','combination(2,2)=get(gco,(''Value''));')
  uicontrol('Style','checkbox','Position',[200 50 100 20],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'String','k','Value',combination(2,3),...
            'Callback','combination(2,3)=get(gco,(''Value''));')


call = ['c=combination;',...
        'if length(find(c(1,:)))==1|length(find(c(2,:)))==1,',...
        '  errormes(''combi'');',...
        'else,close(gcf),',...
        '  if ~isempty(find(combination)),',...
        '    set(findobj(''Label'',''Combination''),''Checked'',''on''),',...
        '    ready(5)=1;if length(ready)==5,check_u1,else check_u2,end;',...
        '  else ',...
        '    set(findobj(''Label'',''Combination''),''Checked'',''off''),',...
        '    if length(ready)==5,check_u1,else check_u2,end;',...
        '  end,',...
        'end,clear c'];

uicontrol(fig,'Style','Pushbutton','Position',[400 125 75 20],...
          'String','OK',...
          'Callback',call)

uicontrol(fig,'Style','Pushbutton','Position',[400 75 75 20],...
          'String','Cancel','UserData',combination,...
          'Callback','combination = get(gco,''UserData'');close(gcf)')
clear fig screen call handle h
end











