        function [ A , b ] = create_s ( vector )
% [A,b] = CREATE_S(VECTOR) creates A and b of the SISO system :
%
%       x(k+1) = Ax(k) + bu(k)
% from :
%       VECTOR = [ -a(n-1) ... -a(0) b(n-1) ... b(0)]'

% Pawel Stadnik July 28 1996
% Copyright (C) 1996 Universiteit Twente
% All Rights Reserved

% vector - [ -a(n-1) ... -a(0) b(n-1) ... b(0)]'

vector = vector(:);

n=length(vector)/2;     % vector is vertical
a = -vector(1:n);       % vertical
b = vector(n+1:n*2);    % vertical
a = flipud(a);          % a = [ a(0) ... a(n-1) ]'
b = flipud(b) ;         % b = [ b(0) ... b(n-1) ]'
A = [[zeros(1,n-1) ; eye(n-1)] -a];
