function [] = mr_fi_st(init_X,n)
if ~isempty(findobj('Name','Initial state'))
   figure(findobj('Name','Initial state'))
   return
end

screen=get(0,'ScreenSize');
fig=figure('MenuBar','none','numberTitle','off','UserData','Figure',...
        'Position',[screen(3)/2-300 screen(4)/2-100 600 200],'Resize','off',...
        'Name','Initial state');
axis off

text(0,0.85,'The initial state:');
if n==1
  text(0,0.6,'[ x\_u(0) ] = ');
  text(0,0.35,'[ x\_y(0) ] = ');
elseif n==2
  text(-0.1,0.6,'[ x\_u(1) x\_u(0) ] = ');
  text(-0.1,0.35,'[ x\_y(1) x\_y(0) ] = ');
else
  string1 = sprintf('[ x\\_u(%d) ... x\\_u(0) ] = ',n-1);
  string2 = sprintf('[ x\\_y(%d) ... x\\_y(0) ] = ',n-1);
  text(-0.1,0.6,string1);
  text(-0.1,0.35,string2);
  clear string1 string2
end

handle = findobj(gcf,'type','text');
set(handle,'HorizontalAlignment','left')

handle1=uicontrol(fig,'Style','edit','Position',[180 110 250 20],'UserData','x_u',...
              'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0]);
handle2=uicontrol(fig,'Style','edit','Position',[180 70 250 20],'UserData','x_y',...
              'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0]);
if ~isempty(init_X)
   set(handle1,'String',mat2str(init_X(1:n)'))
   set(handle2,'String',mat2str(init_X(n+1:2*n)'))
end

call = ['value1=str2num(get(findobj(''UserData'',''x_u''),''String''));',...
        'value2=str2num(get(findobj(''UserData'',''x_y''),''String''));',...
        'if isempty(value1) | isempty(value2),errormes(''data''),',...
        'elseif check_m(value1)==1 | check_m(value2)==1,errormes(''vectors''),',...
        'elseif length(value1)~=n | length(value2)~=n,errormes(''NumberCoefficients'',n''),',...
        'else init_X=[value1(:);value2(:)];ready(3)=1;',...
        '  close(gcf),check_mr;',...
        '  set(findobj(''Label'',''Initial state''),''Checked'',''on''),',...
        '  if ~isempty(findobj(''Name'',''Introduced parameters gallery'')),',...
        '  show_mr,end,',...
        'end,clear value1 value2'];

uicontrol(fig,'Style','Pushbutton','Position',[500 110 75 20],...
          'String','OK','Callback',call)
uicontrol(fig,'Style','Pushbutton','Position',[500 70 75 20],'Userdata',init_X,...
          'String','Cancel','Callback','init_X=get(gco,''UserData'');close(gcf)')

clear call fig screen handle1 handle2

