function [] = phase_pp(phases,n)
% Pawel Stadnik August 30 1997
% All Rights Reserved


if ~isempty(findobj('Name','Phase portraits'))
   figure(findobj('Name','Phase portraits'))
   return
end
%if ~isempty(findobj('Name','Adaptive Pole Assignment'))
  screen=get(0,'ScreenSize');
  fig=figure('MenuBar','none','numberTitle','off','UserData','Figure',...
             'Position',[screen(3)/2-300 screen(4)/2-250 600 500],...
             'Resize','off','Name','Phase portraits');
  axis off

string = str2mat('none','Output','Predicted output','Input','Error','Estimation error',...
                 'Desired/actual input ratio');
pom1 = sprintf('Estimate of "a(%d)" parameter',n-1);
pom2 = sprintf('Estimate of "b(%d)" parameter',n-1);
for ind=2:n
  pom1 = str2mat(pom1,sprintf('Estimate of "a(%d)" parameter',n-ind'));
  pom2 = str2mat(pom2,sprintf('Estimate of "b(%d)" parameter',n-ind'));
end
string = str2mat(string,pom1,pom2);

handle = text(0.5,1,'The plots of selected magnitudes will be displayed in phase portraits.');
set(handle,'HorizontalAlignment','center')

% First figure
han(1)=text(0.47,0.8,'1st figure');
h(1)=uicontrol('Style','listbox','position',[50 320 200 100],'String',string,...
               'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
               'Callback','phases(1,1)=get(gco,''Value'')-1;');
h(2)=uicontrol('Style','listbox','position',[350 320 200 100],'String',string,...
               'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
               'Callback','phases(1,2)=get(gco,''Value'')-1;');
if phases(1,1)==0, 
   set(h(1),'value',1),
   set(h(2),'value',1),
else 
  set(h(1)','value',phases(1,1)+1)
  set(h(2)','value',phases(1,2)+1)
end


% Second figure
han(2)=text(0.48,0.5,'2nd figure');
h(1)=uicontrol('Style','listbox','position',[50 200 200 100],'String',string,...
               'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
               'Callback','phases(2,1)=get(gco,''Value'')-1;');
h(2)=uicontrol('Style','listbox','position',[350 200 200 100],'String',string,...
               'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
               'Callback','phases(2,2)=get(gco,''Value'')-1;');
if phases(2,1)==0, 
   set(h(1),'value',1),
   set(h(2),'value',1),
else 
  set(h(1)','value',phases(2,1)+1)
  set(h(2)','value',phases(2,2)+1)
end

% Third figure
han(3)=text(0.48,0.2,'3rd figure');
h(1)=uicontrol('Style','listbox','position',[50 80 200 100],'String',string,...
               'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
               'Callback','phases(3,1)=get(gco,''Value'')-1;');
h(2)=uicontrol('Style','listbox','position',[350 80 200 100],'String',string,...
               'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
               'Callback','phases(3,2)=get(gco,''Value'')-1;');
if phases(3,1)==0, 
   set(h(1),'value',1),
   set(h(2),'value',1),
else 
  set(h(1)','value',phases(3,1)+1)
  set(h(2)','value',phases(3,2)+1)
end

set(han,'HorizontalAlignment','center')

call = ['if any(phases(1,:)==0), phases(1,:)=[0 0];end,',...
        'if any(phases(2,:)==0), phases(2,:)=[0 0];end,',...
        'if any(phases(3,:)==0), phases(3,:)=[0 0];end,',...
        'close(gcf),',...
        'if any(any(phases)),set(findobj(''Label'',''Phase portraits''),''Checked'',''on''),',...
        'ready(8)=1;else set(findobj(''Label'',''Phase portraits''),''Checked'',''off''),end, check_pp']; 



 uicontrol(fig,'Style','Pushbutton','Position',[200 30 75 20],...
          'String','OK','Callback',call)
 uicontrol(fig,'Style','Pushbutton','Position',[325 30 75 20],...
          'String','Cancel','UserData',phases,...
          'Callback','phases=get(gco,''UserData'');close(gcf)')

