function [] = plot_mr (y,y_r,u,model_error,r,da_in_ratio,ref_sys_out_ratio,Sys,theta,k,...
                        casc,window,many_plots,phases)
%
%
%
%

% Pawel Stadnik December 5 1996
% Copyright (C) 1996 Universiteit Twente
% All Rights Reserved



handles = findobj('UserData','Figure');
close(handles)

vec_of_variables = str2mat('y','y_r','u','model_error','r','da_in_ratio',...
                           'ref_sys_out_ratio');
%                          'output_ref_output');
vec_of_xylab = str2mat('y','y\_r','u','model\_error','r','da\_in\_ratio',...
                           'ref\_sys\_out\_ratio');
                           
vec_of_names = str2mat('System output','Model output','Input',...
                       'Model error','Reference signal',...
                       'Desired/actual input ratio','Reference/system output ratio');
%                       'desired/actual input ratio','output - reference output');

n = (length(Sys)-1)/2;
it = k-1;
k=0:it;


Sys = [flipud(Sys(1:n));flipud(-Sys(n+1:2*n));Sys(2*n+1)];
theta = [flipud(theta(1:n,:));flipud(-theta(n+1:2*n,:));theta(2*n+1,:)];


if ( n == 1 )  sub = [1 1];
elseif ( n == 2 ) sub = [2 1];
elseif ( n == 3 ) sub = [3 1];
elseif ( n == 4 ) sub = [2 2];
elseif ( n == 5 ) sub = [3 2];
elseif ( n == 6 ) sub = [3 2];
elseif ( n == 7 ) sub = [4 2];
elseif ( n == 8 ) sub = [4 2];
else
  val = ceil(sqrt(n))'
  if ( val^2 - n >= val)
    sub = [val (val-1)];
  else
    sub = [val val]
  end
end

true_par = zeros(2*n+1,it+1);
for ind=1:it+1
   true_par(:,ind) = Sys;
end

counter=0;
for i=1:length(casc),
   if (casc(8) == 1 ) & i==8
      figure
      counter=counter+1;
      str=sprintf('Figure No. %d',counter);
      set(gcf,'NumberTitle','off','Name',str,'UserData','Figure');
      uicontrol('Style','PushButton','Position',[5 5 130 20],'Callback',...
           'close(findobj(''UserData'',''Figure''))','String','Close all figures')
      orient landscape;
      for ind=1:n
        subplot(sub(1),sub(2),ind);
        eval(['plot(k,true_par(ind,:),','''yo''',')'])
        hold
        eval(['plot(k,theta(ind,:),','''m''',')'])
        grid;
        xlabel('Iterations ')
        eval(['title(sprintf(''c\\_u(%d) and its estimate'',n-ind))'])
        pom1 = sprintf(' c\\_u(%d)',n-ind);
        pom2 = sprintf(' c\\_u(%d) estimate',n-ind);
        pom =  str2mat(pom1,pom2);
        set(gca,'Color',[0 0 0],'Xcolor',[1 1 1],'Ycolor',[1 1 1])        
        legend(pom);
        hold
      end
   elseif ( casc(9) == 1 ) & i==9
      figure
      counter=counter+1;
      str=sprintf('Figure No. %d',counter);
      set(gcf,'NumberTitle','off','Name',str,'UserData','Figure');
      uicontrol('Style','PushButton','Position',[5 5 130 20],'Callback',...
           'close(findobj(''UserData'',''Figure''))','String','Close all figures')
      orient landscape;
      set(gca,'Color',[0 0 0],'Xcolor',[1 1 1],'Ycolor',[1 1 1])
      for ind=(n+1):(2*n)
        subplot(sub(1),sub(2),ind-n);
        eval(['plot(k,true_par(ind,:),','''yo''',')'])
        hold
        eval(['plot(k,theta(ind,:),','''m''',')'])
        grid;
        xlabel('Iterations ')
        eval(['title(sprintf(''c\\_y(%d) and its estimate'',2*n-ind))'])
        pom1 = sprintf(' c\\_y(%d)',2*n-ind);
        pom2 = sprintf(' c\\_y(%d) estimate',2*n-ind);
        pom =  str2mat(pom1, pom2);
        set(gca,'Color',[0 0 0],'Xcolor',[1 1 1],'Ycolor',[1 1 1])
        legend(pom);
        hold
      end
   elseif ( casc(10) == 1 ) & i==10
      figure
      counter=counter+1;
      str=sprintf('Figure No. %d',counter);
      set(gcf,'NumberTitle','off','Name',str,'UserData','Figure');
      uicontrol('Style','PushButton','Position',[5 5 130 20],'Callback',...
           'close(findobj(''UserData'',''Figure''))','String','Close all figures')
      orient landscape;
      set(gca,'Color',[0 0 0],'Xcolor',[1 1 1],'Ycolor',[1 1 1])
      plot(k,true_par(2*n+1,:),'yo')
      hold
      plot(k,theta(2*n+1,:),'m')
      grid;
      title('c\_r and its estimate')
      xlabel('Iterations')
      pom1 = sprintf(' c\\_r');
      pom2 = sprintf(' c\\_r estimate');
      pom = str2mat(pom1,pom2);
      set(gca,'Color',[0 0 0],'Xcolor',[1 1 1],'Ycolor',[1 1 1])
      legend(pom);
      hold
   else
     if casc(i)~=0
       figure
       counter=counter+1;
       str=sprintf('Figure No. %d',counter);
       set(gcf,'NumberTitle','off','Name',str,'UserData','Figure');
       uicontrol('Style','PushButton','Position',[5 5 130 20],'Callback',...
           'close(findobj(''UserData'',''Figure''))','String','Close all figures')
       orient landscape;
       set(gca,'Color',[0 0 0],'Xcolor',[1 1 1],'Ycolor',[1 1 1])
       eval(['plot(k,',vec_of_variables(i,:),',''y'')'])
       if ((casc(6) == 1) & i==6) | ((casc(7) == 1 ) & i==7)
         axis([0 it -1 3])
       end
       grid;
       xlabel('Iterations')
       if i==6
         ylabel('d/a\_in\_ratio')
       elseif i==7
         ylabel('ref/sys\_out\_ratio')
       else 
         eval(['ylabel(''', deblank(vec_of_xylab(i,:)),''')'])
       end
       eval(['title(''',deblank(vec_of_names(i,:)),''')'])
       set(gca,'Color',[0 0 0],'Xcolor',[1 1 1],'Ycolor',[1 1 1])
       zoom
     end
   end
end

[n,m]=size(window);
for i=1:(n/2)
  if any(window(i,:))
    tmp_vec = window(i,:);
    non_zero = find(tmp_vec);non_zero=max(non_zero);
    tmp_vec = tmp_vec(:,1:non_zero);
    figure
    counter=counter+1;
    str=sprintf('Figure No. %d',counter);
    set(gcf,'NumberTitle','off','Name',str,'UserData','Figure');
    uicontrol('Style','PushButton','Position',[5 5 130 20],'Callback',...
           'close(findobj(''UserData'',''Figure''))','String','Close all figures')
    orient landscape;
    set(gca,'Color',[0 0 0],'Xcolor',[1 1 1],'Ycolor',[1 1 1])
    for j=1:length(tmp_vec)
        subplot(window((n/2)+i,1),window((n/2)+i,2),j)
        eval(['plot(k,',vec_of_variables(tmp_vec(j),:),',''y'')'])
        if (tmp_vec(j) == 6 ) | ( tmp_vec(j) == 7 )
           axis([0 it -1 3])
        end
        grid;
        xlabel('Iterations')
        if tmp_vec(j)==6
          ylabel('d/a\_in\_ratio')
        elseif tmp_vec(j)==7
          ylabel('ref/sys\_out\_ratio')
        else
          eval(['ylabel(''',deblank(vec_of_xylab(tmp_vec(j),:)),''')'])
        end
        eval(['title(''',deblank(vec_of_names(tmp_vec(j),:)),''')'])
        set(gca,'Color',[0 0 0],'Xcolor',[1 1 1],'Ycolor',[1 1 1])
    end
    zoom
  end
end

colors = ['y';'m';'b';'r';'w';'c';'y'];
[n,m]=size(many_plots);
for i=1:n
  tmp_vec = many_plots(i,:);
  if any(tmp_vec)
     figure
     counter=counter+1;
     str=sprintf('Figure No. %d',counter);
     set(gcf,'NumberTitle','off','Name',str,'UserData','Figure');
     uicontrol('Style','PushButton','Position',[5 5 130 20],'Callback',...
           'close(findobj(''UserData'',''Figure''))','String','Close all figures')
     orient landscape;
     set(gca,'Color',[0 0 0],'Xcolor',[1 1 1],'Ycolor',[1 1 1])
     pom=0;
     for j=1:length(tmp_vec)
       if tmp_vec(j)==1
         eval(['plot(k,',vec_of_variables(j,:),',','''',colors(j),'''',')']);
         pom=pom+1;
         if ( pom == 1 ) hold, end
         xlabel('Iterations');
       end
     end

     pom=[];
     for ind=1:length(tmp_vec)
       if tmp_vec(ind)==1
         pom=str2mat(pom,vec_of_names(ind,:));
       end
     end
     [xx,yy]=size(pom);
     pom = pom(2:xx,:);
     set(gca,'Color',[0 0 0],'Xcolor',[1 1 1],'Ycolor',[1 1 1])
     legend(pom)
     grid;
     hold
     zoom
  end
end



n=(length(Sys)-1)/2;

pom1 = sprintf('Estimate of "c\\_u(%d)" parameter',n-1);
pom2 = sprintf('Estimate of "c\\_y(%d)" parameter',n-1);

for ind=2:n
  pom1 = str2mat(pom1,sprintf('Estimate of "c\\_u(%d)" parameter',n-ind'));
  pom2 = str2mat(pom2,sprintf('Estimate of "c\\_y(%d)" parameter',n-ind'));
end
pom3 = 'Estimate of "c\_r" parameter';
vec_of_names = str2mat(vec_of_names,pom1,pom2,pom3);

pom1 = 'theta(1,:)';
pom2 = 'theta(1+n,:)';
for ind=2:n
  pom1 = str2mat(pom1,sprintf('theta(%d,:)',ind));
  pom2 = str2mat(pom2,sprintf('theta(%d,:)',n+ind));
end
vec_of_variables = str2mat(vec_of_variables,pom1,pom2,'theta(2*n+1,:)');



for ind=1:3
  if phases(ind,1)~=0
     figure
     counter=counter+1;
     str=sprintf('Figure No. %d',counter);
     set(gcf,'NumberTitle','off','Name',str,'UserData','Figure');
     uicontrol('Style','PushButton','Position',[5 5 130 20],'Callback',...
           'close(findobj(''UserData'',''Figure''))','String','Close all figures')
     orient landscape;
     set(gca,'Color',[0 0 0],'Xcolor',[1 1 1],'Ycolor',[1 1 1])
     eval(['plot(',vec_of_variables(phases(ind,1),:),',',vec_of_variables(phases(ind,2),:),')'])
     grid, zoom,
     xlabel(deblank(vec_of_names(phases(ind,1),:)))
     ylabel(deblank(vec_of_names(phases(ind,2),:)))
     set(gca,'Color',[0 0 0],'Xcolor',[1 1 1],'Ycolor',[1 1 1])          
  end
end

