function [] = plot_uc (y,u,k,switch_fun,t,casc,window,many_plots)


% Pawel Stadnik September 11 1996
% Copyright (C) 1996 Universiteit Twente
% All Rights Reserved


handles = findobj('UserData','Figure');
close(handles)

if size(casc)==[1 4]
  casc = [casc 0];
end
vec_of_variables = str2mat('y','u','k','y',switch_fun);
vec_of_xylab = str2mat('y','u','k','y',switch_fun);

vec_of_names = str2mat('Output',...
                       'Input',...
                       'k(t)',...
                       'phase portrait (k,y)',...
                       'Switching function');

if ( length(switch_fun) ~= 0 )
   eval(['switch_function = ' switch_fun ';'])
end

counter = 0;
for i=1:length(casc),
   if ( casc(4) == 1 ) & i==4
      figure
      counter=counter+1;
      str=sprintf('Figure No. %d',counter);
      set(gcf,'NumberTitle','off','Name',str,'UserData','Figure');
      uicontrol('Style','PushButton','Position',[5 5 130 20],'Callback',...
           'close(findobj(''UserData'',''Figure''))','String','Close all figures')
      orient landscape
      plot(k,y,'y')
      xlabel('k');
      grid;
      eval(['ylabel(''', deblank(vec_of_xylab(i,:)),''')']);
      eval(['title(''',deblank(vec_of_names(i,:)),''')']);
      set(gca,'Color',[0 0 0],'Xcolor',[1 1 1],'Ycolor',[1 1 1])
      zoom
   elseif ( casc(5) == 1 ) & i==5
      figure
      counter=counter+1;
      str=sprintf('Figure No. %d',counter);
      set(gcf,'NumberTitle','off','Name',str,'UserData','Figure');
      uicontrol('Style','PushButton','Position',[5 5 130 20],'Callback',...
           'close(findobj(''UserData'',''Figure''))','String','Close all figures')
      orient landscape
      plot(t,switch_function,'y');        
      xlabel(' Time');
      grid;
      eval(['ylabel(''', deblank(vec_of_xylab(i,:)),''')']);
      eval(['title(''',deblank(vec_of_names(i,:)),''')']);
      set(gca,'Color',[0 0 0],'Xcolor',[1 1 1],'Ycolor',[1 1 1])
      zoom
   else
     if casc(i)~=0
       figure
       counter=counter+1;
       str=sprintf('Figure No. %d',counter);
       set(gcf,'NumberTitle','off','Name',str,'UserData','Figure');
       uicontrol('Style','PushButton','Position',[5 5 130 20],'Callback',...
           'close(findobj(''UserData'',''Figure''))','String','Close all figures')
       orient landscape
       eval(['plot(t,',vec_of_variables(i,:),',''y'')'])
       xlabel(' Time ');
       grid;
       eval(['ylabel(''', deblank(vec_of_xylab(i,:)),''')']);
       eval(['title(''',deblank(vec_of_names(i,:)),''')']);
       set(gca,'Color',[0 0 0],'Xcolor',[1 1 1],'Ycolor',[1 1 1])
       zoom
     end
   end
end


[n,m]=size(window);
for i=1:(n/2)
  if any(window(i,:))
    tmp_vec = window(i,:);
    non_zero = find(tmp_vec);non_zero=max(non_zero);
    tmp_vec = tmp_vec(:,1:non_zero);
    figure
    counter=counter+1;
    str=sprintf('Figure No. %d',counter);
    set(gcf,'NumberTitle','off','Name',str,'UserData','Figure');
    uicontrol('Style','PushButton','Position',[5 5 130 20],'Callback',...
           'close(findobj(''UserData'',''Figure''))','String','Close all figures')
    orient landscape;
    for j=1:length(tmp_vec)
        subplot(window((n/2)+i,1),window((n/2)+i,2),j)
        if ( tmp_vec(j) == 4 )
           plot(k,y,'y');
           xlabel('k');
        elseif ( tmp_vec(j) == 5 )
           plot(t,switch_function,'y');   
           xlabel(' Time ');
        else
            eval(['plot(t,',vec_of_variables(tmp_vec(j),:),',''y'')'])
            xlabel(' Time ');
        end
        grid;
        eval(['ylabel(''',deblank(vec_of_xylab(tmp_vec(j),:)),''')'])
        eval(['title(''',deblank(vec_of_names(tmp_vec(j),:)),''')'])
        set(gca,'Color',[0 0 0],'Xcolor',[1 1 1],'Ycolor',[1 1 1])
    end
    zoom
  end
end

colors = ['y';'m';'b';'r';'w';'c';'y'];
[n,m]=size(many_plots);
for i=1:n
   tmp_vec = many_plots(i,:);
   if any(tmp_vec)
     figure
     counter=counter+1;
     str=sprintf('Figure No. %d',counter);
     set(gcf,'NumberTitle','off','Name',str,'UserData','Figure');
     uicontrol('Style','PushButton','Position',[5 5 130 20],'Callback',...
           'close(findobj(''UserData'',''Figure''))','String','Close all figures')
     orient landscape;
     pom=0;
     for j=1:length(tmp_vec)
       if tmp_vec(j)==1
         eval(['plot(t,',vec_of_variables(j,:),',','''',colors(j),'''',')']);
          pom=pom+1;
          if ( pom == 1 ) hold, end
          xlabel(' Time');
       end
     end
     pom=[];
     for ind=1:length(tmp_vec)
       if tmp_vec(ind)==1
         pom=str2mat(pom,vec_of_names(ind,:));
       end
     end
     [xx,yy]=size(pom);
     pom = pom(2:xx,:);
     set(gca,'Color',[0 0 0],'Xcolor',[1 1 1],'Ycolor',[1 1 1])
     [h1,h2]=legend(pom);
     grid;
     hold
     zoom
   end
end
