function [] = set_est(init_est,n)
if ~isempty(findobj('Name','Initial estimates'))
   figure(findobj('Name','Initial estimates'))
   return
end

screen=get(0,'ScreenSize');
fig=figure('MenuBar','none','numberTitle','off','UserData','Figure',...
        'Position',[screen(3)/2-300 screen(4)/2-100 600 200],'Resize','off',...
        'Name','Initial estimates');
axis off

text(-0.1,0.85,'The initial estimate of the system parameters:');
if n==1
  text(0,0.6,'[ a(0) ] = ');
  text(0,0.35,'[ b(0) ] = ');
elseif n==2
  text(-0.05,0.6,'[ a(1) a(0) ] = ');
  text(-0.05,0.35,'[ b(1) b(0) ] = ');
else
  string1 = sprintf('[ a(%d) ... a(0) ] = ',n-1);
  string2 = sprintf('[ b(%d) ... b(0) ] = ',n-1);
  text(-0.1,0.6,string1);
  text(-0.1,0.35,string2);
  clear string1 string2
end

handle1=uicontrol(fig,'Style','edit','Position',[160 110 250 20],'UserData','a_est',...
              'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0]);
handle2=uicontrol(fig,'Style','edit','Position',[160 70 250 20],'UserData','b_est',...
              'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0]);
if ~isempty(init_est)
   set(handle1,'String',mat2str(-init_est(1:n)'))
   set(handle2,'String',mat2str(init_est(n+1:2*n)'))
end

call = ['value1=str2num(get(findobj(''UserData'',''a_est''),''String''));',...
        'value2=str2num(get(findobj(''UserData'',''b_est''),''String''));',...
        'if isempty(value1) | isempty(value2),errormes(''data''),',...
        '   clear value1 value2,return,',...
        'elseif check_m(value1)==1 | check_m(value2)==1,errormes(''vectors''),',...
        '   clear value1 value2,return,',...
        'elseif length(value1)~=n | length(value2)~=n,errormes(''NumberCoefficients'',n),',...
        '  clear value1 value2,return,',...
        'end,',...
        'n=length(value1);value1=flipud(value1(:));value2=flipud(value2(:));',...
        'if ~det(ctrb([[zeros(1,n-1) ; eye(n-1)] -value1],value2)),',...
        '  errormes(''NotCorrespond''),',...
        'else init_est=[-flipud(value1);flipud(value2)];ready(5)=1;',...
        '  close(gcf),check_pp;',...
        '  set(findobj(''Label'',''Initial estimates''),''Checked'',''on''),',...
        '  if ~isempty(findobj(''Name'',''Introduced parameters gallery'')),',...
        '     show_pp,',...
        '  end,',...
        '  clear value1 value2,',...
        'end'];

uicontrol(fig,'Style','Pushbutton','Position',[500 110 75 20],...
          'String','OK','Callback',call)
uicontrol(fig,'Style','Pushbutton','Position',[500 70 75 20],'Userdata',init_est,...
          'String','Cancel','Callback','init_est=get(gco,''UserData'');close(gcf)')

clear call fig screen handle1 handle2

