function [] = set_fil(filter_polynomial,rho,n)
if ~isempty(findobj('Name','Filter (optional)'))
   figure(findobj('Name','Filter (optional)'))
   return
end

screen=get(0,'ScreenSize');
fig=figure('MenuBar','none','numberTitle','off','UserData','Figure',...
        'Position',[screen(3)/2-250 screen(4)/2-225 500 450],'Resize','off',...
        'Name','Filter (optional)');
axis off

handle(1) = text(-0.1,0.95,'Specify the filter polynomial by introducing');
handle(2) = text(-0.1,0.9,'its coefficients or roots.');

set(handle,'HorizontalAlignment','left')

handle(1) = text(-0.1,0.75,'F(X) = X\^n + c(n-1)*X\^(n-1) ... c(1)*X + c(0).');
handle(1) = text(-0.1,0.55,'F(X) = (X-r(1))*(X-r(2))* ... *(X-r(n)).');
set(handle,'HorizontalAlignment','left')

if n==1
  handle(1) = text(0,0.65,'c(0) =');
  handle(1) = text(0,0.45,'r(1) = ');
elseif n==2
  handle(1) = text(-0.05,0.65,'[c(1) c(0)] =');
  handle(1) = text(-0.05,0.45,'[r(1) r(2)] =');
else
  str1 = sprintf('[c(%d) ... c(0)] =',n-1);
  str2 = sprintf('[r(1) ... r(%d)] =',n);
  handle(1) = text(-0.1,0.65,str1);
  handle(1) = text(-0.1,0.45,str2);
end
pom1=uicontrol(fig,'Style','edit','Position',[150 280 200 20],'UserData','fil_poly_coeff',...
          'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
          'CallBack','set(findobj(get(gcf,''Children''),''String'',''OK''),''UserData'',gco)');
pom2=uicontrol(fig,'Style','edit','Position',[150 205 200 20],'UserData','fil_poly_roots',...
          'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
          'CallBack','set(findobj(get(gcf,''Children''),''String'',''OK''),''UserData'',gco)');
        
if isempty(filter_polynomial)
   set(pom1,'String','');
   set(pom2,'String','');
else  
  r = roots(filter_polynomial);
  set(pom1,'String',mat2str(filter_polynomial(2:length(filter_polynomial))'));
  set(pom2,'String',mat2str(r'));
end
clear str1 str2 pom1 pom2

handle = text(-0.1,0.25,'Specify the "rho"parameter (0 < rho < 1).');
handle = text(-0.1,0.15,'rho =');
set(handle,'HorizontalAlignment','left')

uicontrol(fig,'Style','edit','Position',[70 95 50 20],'UserData','rho',...
          'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
          'String',num2str(rho));

pom=uicontrol(fig,'Style','checkbox','position',[150 20 170 20],...
          'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
          'String','Simulation with filter');
if ~isempty(findobj('Label','Filter (optional)','Checked','on'))
   set(pom,'value',1)
else
   set(pom,'value',0)
end

call = ['value1=str2num(get(get(gco,''UserData''),''String''));',...
        'value2=str2num(get(findobj(''UserData'',''rho''),''String''));',...
        'if isempty(value1)|isempty(value2),errormes(''data''),',...
        'elseif check_m(value1)==1,errormes(''fil_vector'');',...
        'elseif length(value1)~=n,errormes(''NumberCoeff_Roots'',n);',...
        'elseif length(value2)>1|value2<=0|value2>=1,errormes(''rho_scalar''),',...
        'elseif strcmp(get(get(gco,''UserData''),''UserData''),''fil_poly_coeff'') &',...
        '       any(abs(roots([1 ; value1(:)]))>=1),',...
        '       errormes(''stable''),',...
        'elseif strcmp(get(get(gco,''UserData''),''UserData''),''fil_poly_roots'') &',...
        '       any(abs(value1)>=1)',...
        '       errormes(''stable''),',...
        'else ',...
        ' if strcmp(get(get(gco,''UserData''),''UserData''),''fil_poly_coeff''),',...
        '    filter_polynomial=[1; value1(:)];',...
        ' else filter_polynomial=poly(value1)'';',...
        ' end,',...
        ' rho=value2;',...
        ' if get(findobj(''String'',''Simulation with filter''),''Value'')==1,',...
        '    set(findobj(''Label'',''Filter (optional)''),''Checked'',''on''),',...
        ' else set(findobj(''Label'',''Filter (optional)''),''Checked'',''off''),',...
        ' end,',...
        ' ready(2)=1;close(gcf),',...
        ' check_pp;clear value1 value2,',...
        ' if ~isempty(findobj(''Name'',''Introduced parameters gallery'')),',...
        '   show_pp,',...
        ' end,message(''FilIsStable''),',...
        ' if strcmp(get(findobj(''Label'',''Filter (optional)''),''Checked''),''on'')',...
        '    F=[[zeros(1,n-1);eye(n-1)] -flipud(filter_polynomial(2:n+1))];',...
        '    if rho<max(abs(eig(F''))), warnmes(''rho''),clear F,end,',...
        ' end,',...
        'end'];


uicontrol(fig,'Style','Pushbutton','Position',[400 125 75 20],...
          'String','OK','Callback',call,'UserData',findobj('UserData','fil_poly_coeff'))

uicontrol(fig,'Style','Pushbutton','Position',[400 75 75 20],...
          'String','Cancel','UserData',filter_polynomial,...
          'Callback','filter_polynomial=get(gco,''UserData'');close(gcf)')
clear handle fig screen call pom
