if ~isempty(findobj('Name','The matrix P'))
   figure(findobj('Name','The matrix P'))
   return
end

if id==1
  screen=get(0,'ScreenSize');
  fig=figure('MenuBar','none','numberTitle','off','UserData','Figure',...
          'Position',[screen(3)/2-200 screen(4)/2-100 400 200],'Resize','off',...
          'Name','The matrix P');
  axis off

  handle(1) = text(0.1,0.8,'P(0) = k * I.');
  handle(2) = text(0,0.49,' k  = ');
  set(handle,'HorizontalAlignment','left')

  uicontrol(fig,'Style','edit','Position',[100 90 75 20],'UserData','P0',...
          'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
          'String','')

  call = ['value=str2num(get(findobj(''UserData'',''P0''),''String''));',...
          'if isempty(value),errormes(''data''),',...
          'elseif length(value)>1,errormes(''scalar'');',...
          'else close(gcf),',...
          '  if length(ready)==8 RLS_par=value*eye(2*n);ready(4)=1;check_pp;',...
          '  else RLS_par=value*eye(2*n+1);ready(4)=1;check_mr;',...
          '  end,',...
          '  set(findobj(''Label'',''Recursive Least Square''),''Checked'',''on''),',...
          'end,clear value,'];

  uicontrol(fig,'Style','Pushbutton','Position',[300 125 75 20],...
                'String','OK','Callback',call)

  uicontrol(fig,'Style','Pushbutton','Position',[300 75 75 20],...
                'String','Cancel','UserData',RLS_par,...
                'Callback','RLS_par=get(gco,''UserData'');close(gcf)')

else
  screen=get(0,'ScreenSize');
  fig=figure('MenuBar','none','numberTitle','off','UserData','Figure',...
        'Position',[screen(3)/2-250 screen(4)/2-100 500 200],'Resize','off',...
        'Name','The matrix P');
  axis off

  handle(1) = text(0,0.8,'Specify the matrix P.');
  handle(2) = text(-0.1,0.49,' P = ');
  set(handle,'HorizontalAlignment','left')

  uicontrol(fig,'Style','edit','Position',[60 90 280 20],'UserData','P0',...
          'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
          'String','')
  if length(ready)==8
    call = ['value=str2num(get(findobj(''UserData'',''P0''),''String''));',...
            'if isempty(value),errormes(''data''),',...
            'elseif check_m(value)==0,errormes(''P_size'',2*n);',...
            'elseif length(value)~=2*n,errormes(''P_size'',2*n);',...
            'else pom=0;for ind=1:length(value),mat=value(1:ind,1:ind);',...
            '  if det(mat)>0,pom=pom+1;end,end,if pom~=2*n,',...
            '    errormes(''P_not_pos''),return,',...
            '  end,',...
            '  RLS_par=value;close(gcf),',...
            '  set(findobj(''Label'',''Recursive Least Square''),''Checked'',''on''),',...
            '  ready(4)=1;check_pp,',...
            'end,clear value,'];
  else
      call = ['value=str2num(get(findobj(''UserData'',''P0''),''String''));',...
            'if isempty(value),errormes(''data''),',...
            'elseif check_m(value)==0,errormes(''P_size'',2*n+1);',...
            'elseif length(value)~=2*n+1,errormes(''P_size'',2*n+1);',...
            'else pom=0;for ind=1:length(value),mat=value(1:ind,1:ind);',...
            '  if det(mat)>0,pom=pom+1;end,end,if pom~=2*n+1,',...
            '    errormes(''P_not_pos''),return,',...
            '  end,',...
            '  RLS_par=value;close(gcf),',...
            '  set(findobj(''Label'',''Recursive Least Square''),''Checked'',''on''),',...
            '  ready(4)=1;check_mr,',...
            'end,clear value,'];
  end

  uicontrol(fig,'Style','Pushbutton','Position',[400 125 75 20],...
                'String','OK','Callback',call)

  uicontrol(fig,'Style','Pushbutton','Position',[400 75 75 20],...
                'String','Cancel','UserData',RLS_par,...
                'Callback','RLS_par=get(gco,''UserData'');close(gcf)')
end

clear handle fig screen call
