function [y,y_r,u,model_error,r,da_in_ratio,ref_sys_out_ratio] = sim_mr(theta_sys,...
                   bm_bar,E_poly,which_sig,param_sig,init_est,...
             init_st,init_X,H_poly,threshold,k,matrix,casc,window,many_plots,phases)
%
%
%

% Pawel Stadnik November 28 1996
% Copyright (C) 1996 Universiteit Twente
% All Rights Reserved

disp(blanks(5)')
disp('                           CALCULATIONS')
N = length(theta_sys)+1;
n = length(theta_sys)/2;


%theta_sys,bm_bar,E_poly,pause
%rmodel_signal,init_est,init_st,pause
%init_X,H_poly,pause
%threshold,pause

% H_poly = [1 h(n-1) h(n-2) ... h(0)]'
% E_poly = [1 e(n_r-1) e(n_r-2) ... e(0)]'
% theta_sys = [-a(n-1) ... -a(0) -b(n-1) ... b(0)]'
% init_est = [ c_u(n-1) c_u(0) c_y(n-1) ... c_y(0) c_r]'
% init_st = [ y(0) y(-1) ... y(n-1) u(-1) ... u(n-1)]'
% init_X = [x_u(n-1) ... x_u(0) x_y(n-1) ... x_y(0)]'


screen=get(0,'ScreenSize');
fig=figure('MenuBar','none','NumberTitle','off','Resize','off','UserData','Figure',...
        'Position',[screen(3)/2-200 screen(4)/2-100 400 200]);axis off
handle=text(0.5,0.5,'The simulation is in progress');
set(handle,'HorizontalAlignment','center','FontSize',18,'Color',[1 1 0])
pause(1)

A = [1 -theta_sys(1:n)'];
B = theta_sys(n+1:2*n)';
pom = find(B);
b_m = B(pom(1)); 
E_H = conv(E_poly',H_poly');            % E_H = [1 E_H(n+n_r-1) ... E_H(0)]
[R,C] = deconv(E_H,A);
C = C/b_m;                              % create C polynomial
C = C';
F = conv(R,B)'/b_m;                     % create F polynomial
F = flipud(F);F = F(1:n+1);F = flipud(F);


c_u = flipud(H_poly(2:n+1)-F(2:n+1));
c_y = -flipud(C);
c_y = c_y(1:n);
c_r = 1/b_m;


sys = [c_u; c_y; c_r];
[A_p,b_p] = create_s(theta_sys);
A_H = [zeros(n-1,1) eye(n-1);[-flipud(H_poly(2:n+1))]'];
B_H = [zeros(n-1,1); 1];


theta = [init_est zeros(N,k-1)];
%theta = [sys zeros(N,k-1)];
u = zeros(1,k);
y = zeros(1,k);y(1) = init_st(1);
output_ref_output = zeros(1,k);
ref_sys_out_ratio = ones(1,k);
model_error = zeros(1,k);
da_in_ratio = ones(1,k);
y_r = zeros(1,k);

v = zeros(1,k);
psi = zeros(N,k);
phi = zeros(N,k);


% calculating reference signal

r = ones(1,k);

if ( which_sig == 1 ) % constant
   r = r*param_sig;
elseif ( which_sig == 2 ) % white noise
   r = param_sig*(rand(1,k)-0.5);
elseif ( which_sig == 3 )
   Ampl = param_sig(1,:);
   Freq = param_sig(2,:);
   Phase = param_sig(3,:);
   r_sig = [num2str(Ampl(1)) '*sin(' num2str(Freq(1)) '*k+' num2str(Phase(1)) ')'];
   for ind=2:length(Ampl)
     r_sig = [ r_sig ' + ' num2str(Ampl(ind)) '*sin(' num2str(Freq(ind)) '*k+' num2str(Phase(ind)) ')']; 
   end
   tmp_k = k; k = 0:tmp_k-1;
   r = eval(r_sig);
   k = tmp_k;
elseif ( which_sig == 4 )
   x0 = 2*[rand-0.5; rand-0.5];
   E = param_sig(1:2)';
   E_3 = param_sig(3);
   for ind=1:k 
     r(ind) = [1 0]*x0 + 2*(rand-0.5)*E_3;
     x0 = [1 1;0 1]*x0 + 2*diag([rand-0.5; rand-0.5])*E;
   end
elseif ( which_sig == 5 )
   r = param_sig*((-1).^[1:k]);
end


x_u = zeros(n,k);
x_y = zeros(n,k);

x_u(:,1) = init_X(1:n);
x_y(:,1) = init_X(n+1:2*n);
psi(:,1) = [x_u(:,1); x_y(:,1); r(1)];

u(1) = theta(:,1)'*psi(:,1);
da_in_ratio(1) = (sys'*psi(:,1))/u(1);

v_tmp = zeros(1,length(E_poly)-1);
y_r_tmp = zeros(1,length(E_poly)-1);
phi_u_tmp = zeros(n,length(E_poly)-1);
phi_y_tmp = zeros(n,length(E_poly)-1);


%[phi_u_tmp,phi_y_tmp,v_tmp,y_r_tmp] = ...
%   phi_uy(phi_u_tmp,phi_y_tmp,v_tmp,y_r_tmp,x_u(:,1),x_y(:,1),u(1),r(1),E_poly);
%phi(:,1) = [phi_u_tmp(:,1); phi_y_tmp(:,1); y(1)];
%v(1) = v_tmp(1);
%y_r(1) = y_r_tmp(1); 

x = s2x0(theta_sys,init_st);


v(1:length(E_poly)-1)=rand(1,length(E_poly)-1);
y_r(1:length(E_poly)-1)=rand(1,length(E_poly)-1);
phi(:,1:length(E_poly)-1)=rand(N,length(E_poly)-1);

%v(1:length(E_poly)-1)=zeros(1,length(E_poly)-1);
%y_r(1:length(E_poly)-1)=zeros(1,length(E_poly)-1);
%phi(:,1:length(E_poly)-1)=zeros(N,length(E_poly)-1);

phi(N,1) = y(1);

v_tmp = v(1:length(E_poly)-1);
y_r_tmp = y_r(1:length(E_poly)-1);
phi_u_tmp = phi(1:n,1:length(E_poly)-1);
phi_y_tmp = phi(n+1:2*n,1:length(E_poly)-1);

%e(1) = sys'*phi - theta(:,1)'*phi(:,1);
model_error(1) = v(1) - theta(:,1)'*phi(:,1);


ll = fix(k/10);counter=1;

%matrix,a=length(matrix),pause

for index=2:k;%length(E_poly):k
   if ( index == counter*ll )
        disp(sprintf('%d %%',10*counter))
        counter = counter+1;
   end
%   if ( norm(psi) <= threshold )
%       theta(:,index) = theta(:,index-1);
%   else
     if ( size(matrix) == [N N] )
       [theta(:,index),matrix] = ...
          est_rls(theta(:,index-1),phi(:,index-1),model_error(index-1),matrix);
     elseif ( size(matrix) == [1 2] )
       theta(:,index) = ...
         est_nlms(theta(:,index-1),phi(:,index-1),model_error(index-1),matrix(1),matrix(2));
     elseif ( size(matrix) == [1 1] )
       theta(:,index) = est_lms(theta(:,index-1),phi(:,index-1),model_error(index-1),matrix);
     end
   if (theta(N,index) <= (1/bm_bar))
       theta(:,index) = theta(:,index) + [zeros(N-1,1); -theta(N,index)+1/bm_bar];
   end
%end
%   theta(:,index) = sys;

   x = A_p*x + b_p*u(index-1);
   y(index) = x(n);

%   k = index;
%   r(index) = eval([rmodel_signal]);

   x_u(:,index) = A_H*x_u(:,index-1) + B_H*u(index-1);
   x_y(:,index) = A_H*x_y(:,index-1) + B_H*y(index-1);
   psi(:,index) = [x_u(:,index); x_y(:,index); r(index)];

   u(index) = theta(:,index)'*psi(:,index);
   da_in_ratio(index) = (sys'*psi(:,index))/u(index);

   if ( (index-length(E_poly))>0 )
     [phi_u_tmp,phi_y_tmp,v_tmp,y_r_tmp] = phi_uy(phi_u_tmp,phi_y_tmp,v_tmp,y_r_tmp,...
        x_u(:,index-length(E_poly)+1),x_y(:,index-length(E_poly)+1),...
        u(index-length(E_poly)+1),r(index-length(E_poly)+1),E_poly);
     phi(:,index) = [phi_u_tmp(:,1); phi_y_tmp(:,1); y(index)];
     v(index) = v_tmp(1);
     y_r(index) = y_r_tmp(1);
   else 
     phi(N,index) = y(index); 
   end

   output_ref_output(index)=y(index)-y_r(index);
   ref_sys_out_ratio(index)=y_r(index)/y(index);
   model_error(index) = v(index) - theta(:,index)'*phi(:,index);

end   


if ~isempty(fig)
  close(fig)
end
clear fig

clc
plot_mr (y,y_r,u,model_error,r,da_in_ratio,ref_sys_out_ratio,sys,theta,k,...
         casc,window,many_plots,phases);
if ~all(finite(y))|~all(finite(u))|~all(finite(model_error))| ...
   ~all(finite(da_in_ratio))|~all(finite(ref_sys_out_ratio))
   errormes('NAN')
end

