
% Pawel Stadnik July 29 1996
% All Rights Reserved


if ~isempty(findobj('Name','Tile'))
   figure(findobj('Name','Tile'))
   return
end
if ~isempty(findobj('Name','The sign of the high frequency gain is unknown.'))
  screen=get(0,'ScreenSize');
  fig=figure('MenuBar','none','numberTitle','off','UserData','Figure',...
             'Position',[screen(3)/2-250 screen(4)/2-200 500 400],...
             'Resize','off','Name','Tile');
  axis off

  tmp_xy = window(4:6,1:2);

  handle(1)= text(-0.1,1,'The plots of selected magnitudes will be displayed within figures');
  handle(2)= text(-0.1,0.94,'in a tile format. In this aim, for each figure, one have to form');
  handle(3)= text(-0.1,0.88,'a row vector from indices of magnitudes to be seen and specify');
  handle(4)= text(-0.1,0.82,'two numbers:Y,X where Y denotes the number of plots in a column');
  handle(5)= text(-0.1,0.76,'and X denotes the number of plots in a row.');
  handle(6)= text(-0.1,0.55,'1) Output');
  handle(7)= text(-0.1,0.49,'2) Input');
  handle(8)= text(-0.1,0.43,'3) k');
  handle(8)= text(0.5,0.55,'4) Phase portrait (k,output)');
  handle(9)= text(0.5,0.49,'5) Switching function');
  handle(10)= text(0.4,0.34,'Y');
  handle(11)= text(0.6,0.34,'X');

  set(handle,'HorizontalAlignment','left')
  clear handle screen

  h=uicontrol(fig,'Style','edit','Position',[20 110 150 20],...
            'string','[]',...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'UserData','win1');
  if any(window(1,:))
    set(h,'String',mat2str(window(1,1:max(find(window(1,:))))))
  end
             
  h=uicontrol(fig,'Style','edit','Position',[20 70 150 20],...
            'string','[]',...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'UserData','win2');
  if any(window(2,:))
    set(h,'String',mat2str(window(2,1:max(find(window(2,:))))))
  end
 
  h=uicontrol(fig,'Style','edit','Position',[20 30 150 20],...
            'string','[]',...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'UserData','win3');
  if any(window(3,:))
    set(h,'String',mat2str(window(3,1:max(find(window(3,:))))))
  end


  uicontrol(fig,'Style','popupmenu','Position',[200 110 50 20],...
            'value',window(4,1),'String',[1 2 3 4 5],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'CallBack','tmp_xy(1,1)=get(gco,''Value'');')
  uicontrol(fig,'Style','popupmenu','Position',[200 70 50 20],...
            'value',window(5,1),'string',[1 2 3 4 5],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'CallBack','tmp_xy(2,1)=get(gco,''Value'');')
  uicontrol(fig,'Style','popupmenu','Position',[200 30 50 20],...
            'value',window(6,1),'string',[1 2 3 4 5],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'CallBack','tmp_xy(3,1)=get(gco,''Value'');')


  uicontrol(fig,'Style','popupmenu','Position',[280 110 50 20],...
            'value',window(4,2),'string',[1 2 3 4 5],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'CallBack','tmp_xy(1,2)=get(gco,''Value'');')
  uicontrol(fig,'Style','popupmenu','Position',[280 70 50 20],...
            'value',window(5,2),'string',[1 2 3 4 5],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'CallBack','tmp_xy(2,2)=get(gco,''Value'');')
  uicontrol(fig,'Style','popupmenu','Position',[280 30 50 20],...
            'value',window(6,2),'string',[1 2 3 4 5],...
            'BackGroundColor',[0.7 0.7 0.7],'ForegroundColor',[0 0 0],...
            'CallBack','tmp_xy(3,2)=get(gco,''Value'');')

  call = ['w1=get(findobj(''Userdata'',''win1''),''String'');',...
          'w2=get(findobj(''Userdata'',''win2''),''String'');',...
          'w3=get(findobj(''Userdata'',''win3''),''String'');',...
          'if ~isempty(find(isletter(w1)))|~isempty(find(isletter(w2)))|',...
          ' ~isempty(find(isletter(w3))),',...
          '  errormes(''data''),clear w1 w2 w3,return,',...
          'else w1=str2num(w1);w2=str2num(w2);w3=str2num(w3);',...
              'if check_m(w1)|check_m(w2)|check_m(w3),',...
                  'errormes(''vectors''),clear w1 w2 w3,return,',...
               'end,',...
              'if any(round(w1)-w1)|any(round(w2)-w2)|any(round(w3)-w3)',...
                'errormes(''integer''),clear w1 w2 w3,return,',...
              'end,',...
          'end,',...
          'l(1)=length(w1);l(2)=length(w2);l(3)=length(w3);',...
          'w1=w1(:);w2=w2(:);w3=w3(:);',...
          'if ~isempty(find(l>5)), errormes(''Win>n'',5),',...
          'elseif ~isempty(find(l==1)),errormes(''Win<n'',2);',...
          'elseif ~isempty(find(w1>5))|~isempty(find(w2>5))|~isempty(find(w3>5))|',...
          '~isempty(find(w1<1))|~isempty(find(w2<1))|~isempty(find(w3<1)),',...
          'errormes(''Win<1,n>'',5),',...
          'else w1=w1'';w2=w2'';w3=w3'';',...
          ' window(1,:)=[w1 zeros(1,5-l(1))];window(2,:)=[w2 zeros(1,5-l(2))];',...
          ' window(3,:)=[w3 zeros(1,5-l(3))];',...
          ' if l(1)>tmp_xy(1,1)*tmp_xy(1,2)|l(2)>tmp_xy(2,1)*tmp_xy(2,2)|',...
          '   l(3)>tmp_xy(3,1)*tmp_xy(3,2),',...
          '   errormes(''tile_posit''),clear w1 w2 w3 l,return,',...
          ' end,',...
          ' if any(window(1,:)),window(4,1:2)=tmp_xy(1,:);else window(4,1:2)=[1 1];end,',...
          ' if any(window(2,:)),window(5,1:2)=tmp_xy(2,:);else window(5,1:2)=[1 1];end,',...
          ' if any(window(3,:)),window(6,1:2)=tmp_xy(3,:);else window(6,1:2)=[1 1];end,',...
          ' clear w1 w2 w3 l tmp_xy,close(gcf),',...
          ' if isempty(find(window(1:3,1:3))),',...
          '   set(findobj(''Label'',''Tile''),''Checked'',''off''),',...
          ' else set(findobj(''Label'',''Tile''),''Checked'',''on''),ready(5)=1;',...
          ' end,check_u2,',...
          'end']; 
 
  uicontrol(fig,'Style','Pushbutton','Position',[380 100 75 20],...
          'String','OK','Callback',call)
  uicontrol(fig,'Style','Pushbutton','Position',[380 50 75 20],...
          'String','Cancel','UserData',window,...
          'Callback','window=get(gco,''UserData'');close(gcf), clear tmp_xy')
  clear call fig h
end
